module Hephaestus
  class Collector
    class << self
      %i(all_orphans
        all_empty_has_many
        all_empty_has_one
        all_empty_has_and_belongs_to_many
        all_analyze_deviation).each do |method|

        define_method(method) do |options = {}|
          method_name = __method__.to_s.gsub('all_', '')
          build_statistics(method_name, options)
        end
      end

      def all_empty_relations(options = {})
        {
          orphans: all_orphans(options),
          empty_has_many: all_empty_has_many(options),
          empty_has_one: all_empty_has_one(options),
          empty_has_and_belongs_to_many: all_empty_has_and_belongs_to_many(options)
        }
      end

      private

      def build_statistics(method, options)
        project_classes.map do |klass|
          { class: klass.name, data: Hephaestus::Statistic.new(klass).send(method, options) }
        end
      end

      def project_classes
        Rails.application.eager_load!
        ActiveRecord::Base.descendants
      end
    end
  end
end
